import { defineStore } from 'pinia'

class Key {
  constructor(base64) {
    this.base64 = base64
    this.raw = Uint8Array.from(window.atob(base64), c => c.charCodeAt(0))
  }
}

export const useChannelStore = defineStore({
  id: 'channelStore',
  state: () => ({
    channels: [
      {
        id: 'a798423c-3fbf-434d-9a00-57d7642bff65',
        name: 'Default',
        key: new Key('')
      },
      {
        id: '47198ee7-8bf4-41fe-8b42-bb001bd5f140',
        name: 'HackerNews',
        key: new Key('HACKERNEWQAAAAAAAAAAAA==')
      }
    ]
  }),
  getters: {
    getChannelById: (state) => {
      return (channelId) => state.channels.find((channel) => channel.id === channelId)
    }
  },
  actions: {
    addChannel(channel) {
      this.channels.push(channel)
    }
  }
})